import * as server from "@minecraft/server"
const world = server.world

world.afterEvents.playerPlaceBlock.subscribe(data => {
   if (data.block.typeId == "ksb:ancient_table") {
      const dimension = data.block.dimension;
      const loc = data.block.location;
      dimension.spawnEntity('ksb:ancient_table', {
         x: loc.x + 0.5,
         y: loc.y,
         z: loc.z + 0.5
      })
   } else return;
})

world.beforeEvents.playerBreakBlock.subscribe(data => {
   const dimension = data.block.dimension;
   const playerLocation = data.block.location;
   if (data.block.typeId == "ksb:ancient_table") {
      const entitiesToDelete = dimension.getEntities({
         location: playerLocation,
         type: "ksb:ancient_table",
         minDistance: 0,
         maxDistance: 1
      })
      for (let i = 0; i < entitiesToDelete.length; i++) {
         const currentEntity = entitiesToDelete[i]
         if (currentEntity.typeId == "ksb:ancient_table") {
            server.system.run(() => {
               currentEntity.remove()
            });

         }
      }
   }
})

